using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;

namespace XnaTapHello
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        Random rand = new Random();
        string text = "Hello, Windows Phone 7!";
        SpriteFont kootenay14;
        Vector2 textSize;
        Vector2 textPosition;
        Color textColor = Color.White;
        bool requiresDraw = true;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            TargetElapsedTime = TimeSpan.FromTicks(333333);

            graphics.PreferredBackBufferWidth = 480;
            graphics.PreferredBackBufferHeight = 800;
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);

            kootenay14 = this.Content.Load<SpriteFont>("Kootenay14"); 
            Rectangle clientBounds = this.Window.ClientBounds;
            textSize = kootenay14.MeasureString(text);
            textPosition =
                new Vector2((int)(clientBounds.X + (clientBounds.Width - textSize.X) / 2),
                            (int)(clientBounds.Y + (clientBounds.Height - textSize.Y) / 2));
        }

        protected override void UnloadContent()
        {
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            TouchCollection touchLocations = TouchPanel.GetState();

            foreach (TouchLocation touchLocation in touchLocations)
            {
                if (touchLocation.State == TouchLocationState.Pressed)
                {
                    Vector2 touchPosition = touchLocation.Position;

                    if (touchPosition.X >= textPosition.X &&
                        touchPosition.X < textPosition.X + textSize.X &&
                        touchPosition.Y >= textPosition.Y &&
                        touchPosition.Y < textPosition.Y + textSize.Y)
                    {
                        textColor = new Color((byte)rand.Next(256),
                                              (byte)rand.Next(256),
                                              (byte)rand.Next(256));
                    }
                    else
                    {
                        textColor = Color.White;
                    }
                    requiresDraw = true;
                }
            }

            if (!requiresDraw)
                SuppressDraw();

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            this.GraphicsDevice.Clear(Color.Navy);

            spriteBatch.Begin();
            spriteBatch.DrawString(kootenay14, text, textPosition, textColor);
            spriteBatch.End();

            requiresDraw = false;

            base.Draw(gameTime);
        }
    }
}
