using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace NaiveTextMovement
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        const float SPEED = 240f / 1000;      // pixels per millisecond
        const string TEXT = "Hello, Windows Phone!";

        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont kootenay14;
        Rectangle clientBounds;
        Vector2 textSize;
        Vector2 textPosition;
        bool isGoingUp = false;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            graphics.IsFullScreen = true;       // TODO: Remove when ClientBounds is working!
            Content.RootDirectory = "Content";
            TargetElapsedTime = TimeSpan.FromTicks(333333);

            graphics.PreferredBackBufferWidth = 480;
            graphics.PreferredBackBufferHeight = 800;
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);
            clientBounds = this.Window.ClientBounds;
            kootenay14 = this.Content.Load<SpriteFont>("Kootenay14");
            textSize = kootenay14.MeasureString(TEXT);
            textPosition = new Vector2((int)(clientBounds.X + (clientBounds.Width - textSize.X) / 2), 0);
        }

        protected override void UnloadContent()
        {
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            if (!isGoingUp)
            {
                textPosition.Y += SPEED * (float)gameTime.ElapsedGameTime.TotalMilliseconds;
                if (textPosition.Y + textSize.Y > clientBounds.Bottom)
                {
                    float excess = textPosition.Y + textSize.Y - clientBounds.Bottom;
                    textPosition.Y -= 2 * excess;
                    isGoingUp = true;
                }
            }
            else
            {
                textPosition.Y -= SPEED * (float)gameTime.ElapsedGameTime.TotalMilliseconds;

                if (textPosition.Y < clientBounds.Top)
                {
                    float excess = clientBounds.Top - textPosition.Y;
                    textPosition.Y += 2 * excess;
                    isGoingUp = false;
                }
            }
            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Navy);

            spriteBatch.Begin();
            spriteBatch.DrawString(kootenay14, TEXT, textPosition, Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
